// #define CORE5_MODULE_START_CODE
// #include "Mem_Map.h" /* PRQA S 5087 */ /* MD_MSR_MemMap */

/*to**********************do
1.Rte_GetCANMsgTime
to**********************do*/

#include "VED_Rte_Wrapper.h"
#include "Rte_VED.h"
#include "ved_ext.h"
#include "string.h"
#include "Com_Cfg.h"
//#include "Mcu2Soc_Test.h"
// #include "vlc_parameter.h"

#define CAL_START_CODE
#include "Mem_Map.h"
volatile unsigned char STEERING_OFFSET_STATE = 2u;
volatile float STEERING_ANGLE_THRESHOLD = 15.f;
volatile float STANDSTILL_OFFSET_THRESOLD = 0.087260034f;

#define CAL_STOP_CODE
#include "Mem_Map.h"

#define COUNT_RUNNING_MAX (uint64)180000;
#define COUNT_STANDSTILL_MAX (uint16)300;

#define ASW_QM_CORE5_MODULE_START_SEC_VAR_UNSPECIFIED
#include "ASW_MemMap.h"
// input ports
static reqVEDPrtList_t g_VED_reqPorts = {0};
static BSW_s_VEDCtrlData_t g_pCtrl = {0};
static VEDVehSig_t g_pVehicleInputSignals = {0};
static VEDNvIoDatas_t g_pNVMRead = {0};
static VEDALN_Monitoring_t g_pAln_Monitoring = {0};

// VED Params
static reqVEDParams_t g_VED_reqParams = {0};

// output ports
static proVEDPrtList_t g_VED_proPorts = {0};
static VEDVehDyn_t g_pVehicleDynamicSignals = {0};
static VEDNvIoDatas_t g_pNVMWrite = {0};
static VED_Errors_t g_pVED_Errors = {0};
static VED_VEDOffsets_t g_pVED_Offsets = {0};
static VED_EstCurves_t g_pVED_EstCurves = {0};
static VEDVehSig_t g_pOriginVehicleSignals = {0};
static float g_ACU2_LatAccSensorValue = 0.f;
// RENDL
static uint8 uCDCS11_VoiceMode;
static boolean VED_operation_status_check = 0;

#define ASW_QM_CORE5_MODULE_STOP_SEC_VAR_UNSPECIFIED
#include "ASW_MemMap.h"

#define ASW_QM_CORE5_MODULE_START_SEC_VAR_NO_INIT_UNSPECIFIED
#include "ASW_MemMap.h"
// other
// static StbM_TimeStampType timeStamp;
// static StbM_UserDataType userData;
static uint64 globalTime;
// static float ACU2_LatAccSensorValue = 0.f;
static Timestamp CanMsgInTimeStamp;
static ST_VEDNvIoDatas_t g_VEDNVRAM_Data;
ST_VED_CANIn VedCANInData;
#define ASW_QM_CORE5_MODULE_STOP_SEC_VAR_NO_INIT_UNSPECIFIED
#include "ASW_MemMap.h"

// #ifndef RTE_TYPE_EPS_TimeStamp
// # define RTE_TYPE_EPS_TimeStamp
// typedef struct
// {
//   uint8 timeBaseStatus;
//   uint32 nanoseconds;
//   uint32 seconds;
//   uint16 secondsHi;
// } EPS_TimeStamp;
// #endif //

// static void Rte_GetVEDCANMsgTime(Timestamp *pTimestamp) {
//     EPS_TimeStamp epsTimeStamp;
//     if (Rte_Read_IDB_Fr03_Timestamp_IDB_Fr03_Timestamp(&epsTimeStamp) == E_OK) {
//         if (epsTimeStamp.seconds != 0 || epsTimeStamp.nanoseconds != 0) {
//             pTimestamp->is_valid = 1;
//         } else {
//             pTimestamp->is_valid = 0;
//         }
//         pTimestamp->secs = epsTimeStamp.seconds;
//         pTimestamp->nsecs = epsTimeStamp.nanoseconds;
//     } else {
//         pTimestamp->is_valid = 0;
//         pTimestamp->secs = 0;
//         pTimestamp->nsecs = 0;
//     }
// }

// Read data from CAN, Send to other VED
#define VED_CANIN_STATUS_MAP(status) (status == 0 ? 1 : 0)

static void ST_CANMsg_Read_VED_CANIn() {
    uint8 status;
    // VED_CANIn CAN_Msg_Time
    // Rte_GetVEDCANMsgTime(&(VedCANInData.CAN_Msg_Time));
    VedCANInData.uiVersionNumber = 0u;
    VedCANInData.sSigHeader.eSigStatus = 1;
    VedCANInData.sSigHeader.uiCycleCounter += 1;
    VedCANInData.sSigHeader.uiMeasurementCounter += 1;
    VedCANInData.sSigHeader.uiTimeStamp = 0;
    // VED_CANIn VEDVehSigMain_t
    Rte_Read_BCS_YawRate_BCS_YawRate(
        &(VedCANInData.VehSigMain.YawRate));
    VedCANInData.VehSigMain.YawRateTemp = 0;  // Default
    Rte_Read_EPS_SteeringAngle_EPS_SteeringAngle(
        &(VedCANInData.VehSigMain.StWheelAngle));
    Rte_Read_BCS_ActVehLaltrlAccel_BCS_ActVehLaltrlAccel(
        &(VedCANInData.VehSigMain.LatAccel));
    Rte_Read_BCS_FLWheelSpd_BCS_FLWheelSpd(
        &(VedCANInData.VehSigMain.WhlVelFrLeft));
    Rte_Read_BCS_FRWheelSpd_BCS_FRWheelSpd(
        &(VedCANInData.VehSigMain.WhlVelFrRight));
    Rte_Read_BCS_RLWheelSpd_BCS_RLWheelSpd(
        &(VedCANInData.VehSigMain.WhlVelReLeft));
    Rte_Read_BCS_RRWheelSpd_BCS_RRWheelSpd(
        &(VedCANInData.VehSigMain.WhlVelReRight));
    VedCANInData.VehSigMain.YawRateInt = 0;      // Default
    VedCANInData.VehSigMain.YawRateIntTemp = 0;  // Default
    VedCANInData.VehSigMain.LongAccel = 0;       // Default
    VedCANInData.VehSigMain.RearWhlAngle = 0;    // Default
    Rte_Read_BCS_VehSpd_BCS_VehSpd(
        &(VedCANInData.VehSigMain.VehVelocityExt));
    Rte_Read_BCS_ActVehLongAccel_BCS_ActVehLongAccel(
        &(VedCANInData.VehSigMain.VehLongAccelExt));
    Rte_Read_BCS_FLWheelRotatedDirection_BCS_FLWheelRotatedDirection(
        &(VedCANInData.VehSigMain.WhlDirFrLeft));
    Rte_Read_BCS_FRWheelRotatedDirection_BCS_FRWheelRotatedDirection(
        &(VedCANInData.VehSigMain.WhlDirFrRight));
    Rte_Read_BCS_RLWheelRotatedDirection_BCS_RLWheelRotatedDirection(
        &(VedCANInData.VehSigMain.WhlDirReLeft));
    Rte_Read_BCS_RRWheelRotatedDirection_BCS_RRWheelRotatedDirection(
        &(VedCANInData.VehSigMain.WhlDirReRight));
    // TODO(Zhanghanqi): use these temporarily
    Rte_Read_BCS_FLWheelSpdEdgesSum_BCS_FLWheelSpdEdgesSum(
        &VedCANInData.VehSigMain.WhlTicksDevFrLeft);
    Rte_Read_BCS_FRWheelSpdEdgesSum_BCS_FRWheelSpdEdgesSum(
        &VedCANInData.VehSigMain.WhlTicksDevFrRight);
    Rte_Read_BCS_RLWheelSpdEdgesSum_BCS_RLWheelSpdEdgesSum(
        &VedCANInData.VehSigMain.WhlTicksDevReLeft);
    Rte_Read_BCS_RRWheelSpdEdgesSum_BCS_RRWheelSpdEdgesSum(
        &VedCANInData.VehSigMain.WhlTicksDevReRight);
    Rte_Read_VCU_CrntGearLvl_VCU_CrntGearLvl(
        &(VedCANInData.VehSigMain.ActGearPos));
    VedCANInData.VehSigMain.BrakeActLevel = 0;  // Default

    Rte_Read_EPB_SysSt_EPB_SysSt(
        &(VedCANInData.VehSigMain.ParkBrakeState));
    VedCANInData.VehSigMain.VehLongDirExt = 0;  // Default
    Rte_Read_BCS_VehicleStandStillSt_BCS_VehicleStandStillSt(
        &(VedCANInData.VehSigMain.VehLongMotStateExt));
    VedCANInData.VehSigMain.CurveC0Ext = 0;        // Default
    VedCANInData.VehSigMain.CurveC1Ext = 0;        // Default
    VedCANInData.VehSigMain.SideSlipAngleExt = 0;  // Default
    Rte_Read_EPS_SteeringAngleSpd_EPS_SteeringAngleSpd(
        &(VedCANInData.VehSigMain.fStWheelAngleGradient_nu));

    Rte_Read_BCS_YawRateSt_BCS_YawRateSt(
        &status);
    VedCANInData.VehSigMain.state[0] = VED_CANIN_STATUS_MAP(status);
    VedCANInData.VehSigMain.state[1] = 1;  //  Default
    Rte_Read_EPS_SteeringAngleVD_EPS_SteeringAngleVD(
        &status);
    VedCANInData.VehSigMain.state[2] = VED_CANIN_STATUS_MAP(status);
    Rte_Read_BCS_ActVehLaltrlAccelVD_BCS_ActVehLaltrlAccelVD(
        &status);
    VedCANInData.VehSigMain.state[3] = VED_CANIN_STATUS_MAP(status);
    Rte_Read_BCS_FLWheelSpdVD_BCS_FLWheelSpdVD(
        &status);
    VedCANInData.VehSigMain.state[4] = VED_CANIN_STATUS_MAP(status);
    Rte_Read_BCS_FRWheelSpdVD_BCS_FRWheelSpdVD(
        &status);
    VedCANInData.VehSigMain.state[5] = VED_CANIN_STATUS_MAP(status);
    Rte_Read_BCS_RLWheelSpdVD_BCS_RLWheelSpdVD(
        &status);
    VedCANInData.VehSigMain.state[6] = VED_CANIN_STATUS_MAP(status);
    Rte_Read_BCS_RRWheelSpdVD_BCS_RRWheelSpdVD(
        &status);
    VedCANInData.VehSigMain.state[7] = VED_CANIN_STATUS_MAP(status);
    VedCANInData.VehSigMain.state[8] =
        1;  // YawRateInt_Valid, Default
    VedCANInData.VehSigMain.state[9] =
        1;  // YawRateIntTemp_Valid, Default

    VedCANInData.VehSigMain.state[10] = 1;
    VedCANInData.VehSigMain.state[11] =
        1;  // RearWhlAngle_Valid, Default
    Rte_Read_BCS_VehSpdVD_BCS_VehSpdVD(
        &status);
    VedCANInData.VehSigMain.state[12] = VED_CANIN_STATUS_MAP(status);
    Rte_Read_BCS_ActVehLongAccelVD_BCS_ActVehLongAccelVD(
        &status);
    VedCANInData.VehSigMain.state[13] = VED_CANIN_STATUS_MAP(status);
    VedCANInData.VehSigMain.state[14] =
        0;  // WhlDirFrLeft_Valid, Default
    VedCANInData.VehSigMain.state[15] =
        0;  // WhlDirFrRight_Valid, Default
    VedCANInData.VehSigMain.state[16] =
        0;  // WhlDirReLeft_Valid, Default
    VedCANInData.VehSigMain.state[17] =
        0;  // WhlDirReRight_Valid, Default
    Rte_Read_BCS_FRWheelSpdEdgesSumVD_BCS_FRWheelSpdEdgesSumVD(
        &status);
    VedCANInData.VehSigMain.state[18] = VED_CANIN_STATUS_MAP(status);
    Rte_Read_BCS_FLWheelSpdEdgesSumVD_BCS_FLWheelSpdEdgesSumVD(
        &status);
    VedCANInData.VehSigMain.state[19] = VED_CANIN_STATUS_MAP(status);
    Rte_Read_BCS_RLWheelSpdEdgesSumVD_BCS_RLWheelSpdEdgesSumVD(
        &status);
    VedCANInData.VehSigMain.state[20] = VED_CANIN_STATUS_MAP(status);
    Rte_Read_BCS_RRWheelSpdEdgesSumVD_BCS_RRWheelSpdEdgesSumVD(
        &status);
    VedCANInData.VehSigMain.state[21] = VED_CANIN_STATUS_MAP(status);
    Rte_Read_VCU_CrntGearLvlVD_VCU_CrntGearLvlVD(&status);
    VedCANInData.VehSigMain.state[22] = VED_CANIN_STATUS_MAP(status);
    VedCANInData.VehSigMain.state[23] =
        1;  // BrakeActLevel_Valid, Default
    VedCANInData.VehSigMain.state[24] = 0; // ParkBrakeState_Valid, Default: valid
    
    VedCANInData.VehSigMain.state[25] =
        1;  // VehLongDirExt_Valid, Default
    VedCANInData.VehSigMain.state[26] =
        0;  // VehLongMotStateExt_Valid, Default
    VedCANInData.VehSigMain.state[27] =
        1;  // CurveC0Ext_Valid, Default
    VedCANInData.VehSigMain.state[28] =
        1;  // CurveC1Ext_Valid, Default
    VedCANInData.VehSigMain.state[29] =
        1;  // SideSlipAngleExt_Valid, Default
    Rte_Read_EPS_SteeringAngleSpdVD_EPS_SteeringAngleSpdVD(
        &status);
    VedCANInData.VehSigMain.state[30] = VED_CANIN_STATUS_MAP(status);
    // VED_CANIn VEDVehSigAdd_t
    // TODO(liujinjin): the State should have 52 data, but there
    // are only 36 data VED_CANIn VEDVehSigAdd_t rt_Array_UInt8_36_36
    Rte_Read_HVAC_CorrectedExterTempVD_HVAC_CorrectedExterTempVD(
        &status);
    VedCANInData.VehSigAdd.State[0] = VED_CANIN_STATUS_MAP(status);
    VedCANInData.VehSigAdd.State[1] = 0;  // WiperState_Valid, Default
    VedCANInData.VehSigAdd.State[2] = 0;  // WiperStage_Valid, Default
    VedCANInData.VehSigAdd.State[3] =
        1;  // WiperOutParkPos_Valid, Default
    VedCANInData.VehSigAdd.State[4] =
        0;  // WiperWasherFrontState_Valid, Default
    VedCANInData.VehSigAdd.State[5] = 1;  // RainSensor_Valid, Default
    VedCANInData.VehSigAdd.State[6] = 0;  // TurnSignal_Valid, Default
    VedCANInData.VehSigAdd.State[7] =
        0;  // FogLampFront_Valid, Default
    VedCANInData.VehSigAdd.State[8] =
        0;  // FogLampRear_Valid, Default
    VedCANInData.VehSigAdd.State[9] =
        1;  // RoadWhlAngFr_Valid, Default
    VedCANInData.VehSigAdd.State[10] =
        1;  // RoadWhlAngRe_Valid, Default
    VedCANInData.VehSigAdd.State[11] = 0;  // Odometer_Valid, Default
    Rte_Read_VCU_EMS_AccPedalActPstVD_VCU_EMS_AccPedalActPstVD(
        &status);
    VedCANInData.VehSigAdd.State[12] = VED_CANIN_STATUS_MAP(status);
    VedCANInData.VehSigAdd.State[13] = 1;  // KickDown_Valid, Default
    Rte_Read_VCU_EMS_BrkPedalStVD_VCU_EMS_BrkPedalStVD(
        &status);
    VedCANInData.VehSigAdd.State[14] = VED_CANIN_STATUS_MAP(status);
    VedCANInData.VehSigAdd.State[15] =
        0;  // DriverTired_Valid, Default
    VedCANInData.VehSigAdd.State[16] = 1;  // SpeedUnit_Valid, Default
    Rte_Read_ICM_DisFail_ICM_DisFail(
        &VedCANInData.VehSigAdd.State[17]);
    VedCANInData.VehSigAdd.State[18] =
        1;  // TrailerConnection_Valid, Default
    VedCANInData.VehSigAdd.State[19] =
        1;  // TrailerConnBeforeShutDown_Valid, Default
    VedCANInData.VehSigAdd.State[20] =
        1;  // TrailerLengthInput_Valid, Default
    VedCANInData.VehSigAdd.State[21] =
        1;  // ParkAidDet_L_Valid, Default
    VedCANInData.VehSigAdd.State[22] =
        1;  // ParkAidDet_CL_Valid, Default
    VedCANInData.VehSigAdd.State[23] =
        1;  // ParkAidDet_CR_Valid, Default
    VedCANInData.VehSigAdd.State[24] =
        1;  // ParkAidDet_R_Valid, Default
    VedCANInData.VehSigAdd.State[25] =
        0;  // IgnitionSwitch_Valid, Default
    VedCANInData.VehSigAdd.State[26] =
        1;  // eSuspensionSystem_Valid, Default
    VedCANInData.VehSigAdd.State[27] =
        1;  // eHeightLevel_Valid, Default
    VedCANInData.VehSigAdd.State[28] =
        1;  // WheelHeightLevel_Valid, Default
    VedCANInData.VehSigAdd.State[29] =
        0;  // bDriverSeatBelt_nu_Valid, Default
    VedCANInData.VehSigAdd.State[30] =
        1;  // bDoorAllClosed_nu_Valid, Default
    VedCANInData.VehSigAdd.State[31] =
        0;  // bLowBeamActive_nu_Valid, Default
    VedCANInData.VehSigAdd.State[32] =
        0;  // bHighBeamActive_nu_Valid, Default
    VedCANInData.VehSigAdd.State[33] =
        0;  // bHazardLightActive_nu_Valid, Default
    VedCANInData.VehSigAdd.State[34] =
        1;  // fBrakePedalPos_nu_Valid, Default
    VedCANInData.VehSigAdd.State[35] =
        0;  // uFrontLampState_nu_Valid, Default
    VedCANInData.VehSigAdd.State[36] =
        0;  // CDCS11_VoiceMode_Valid, Default
    VedCANInData.VehSigAdd.State[37] =
        0;  // CDCS11_ADAS_SndCtrlOnOff_Valid, Default
    Rte_Read_EPS_StrngWhlTorqVD_EPS_StrngWhlTorqVD(
        &status);
    VedCANInData.VehSigAdd.State[38] =VED_CANIN_STATUS_MAP(status);
    // Rte_Read_CS1_GearPositionReqStValid_ADCS_FD3_CS1_GearPositionReqStValid_ADCS_FD3(
    //     &VedCANInData.VehSigAdd.State[39]);
    VedCANInData.VehSigAdd.State[39] = 0; // todo: remove CS1_GearPositionReqSt from lateral side
    VedCANInData.VehSigAdd.State[40] =
        0;  // EPS2_ADAS_Available_Valid, Default
    VedCANInData.VehSigAdd.State[41] =
        0;  // EPS2_ADAS_Active_Valid, Default
    // Rte_Read_EPS2_MotCntrlValid_ADCS_FD3_EPS2_MotCntrlValid_ADCS_FD3(&VedCANInData.VehSigAdd.State[42]);
    VedCANInData.VehSigAdd.State[42] = 
        1; // set valid: 0x1, Default
    VedCANInData.VehSigAdd.State[43] =
        0;  // EPS2_ADAS_CtrlAbortFeedback_Valid, Default
    VedCANInData.VehSigAdd.State[44] =
        0;  // DDCU1_FLDoorAjar_Valid, Default
    VedCANInData.VehSigAdd.State[45] =
        0;  // DDCU1_RLDoorAjar_Valid, Default
    VedCANInData.VehSigAdd.State[46] =
        0;  // PDCU1_FRDoorAjar_Valid, Default
    VedCANInData.VehSigAdd.State[47] =
        0;  // PDCU1_RRDoorAjar_Valid, Default
    VedCANInData.VehSigAdd.State[48] =
        0;  // BDCS1_TrunkLockSts_Valid, Default
    VedCANInData.VehSigAdd.State[49] =
        0;  // BDCS1_HoodAjarSts_Valid, Default
    VedCANInData.VehSigAdd.State[50] =
        0;  // CDCS5_ResetAllSetup_Valid, Default
    VedCANInData.VehSigAdd.State[51] =
        0; // CDCS5_FactoryReset_Valid, Default
    Rte_Read_HVAC_CorrectedExterTemp_HVAC_CorrectedExterTemp(
        &(VedCANInData.VehSigAdd.EnvTemp)); // EnvTemp

    // VedCANInData.VehSigAdd.EnvTemp
    //   = VedCANInData.VehSigAdd.State[0]; //set BDCS10_AC_OutsideTemp = HVAC_CorrectedExterTempVD
    // Rte_Read_CS1_FrontWiperMISTReqSt_ADCS_FD3_CS1_FrontWiperMISTReqSt_ADCS_FD3(
    //    &(VedCANInData.VehSigAdd.WiperState));
    VedCANInData.VehSigAdd.WiperState = 
        0;  //set 0x0 : inactive, Default

    uint8 FrontWiperSt_temp;
    Rte_Read_BCM_FrontWiperSt_BCM_FrontWiperSt(
        &(FrontWiperSt_temp));
    /*EP40:
    0x0锛歄FF 
    0x1锛歁IST锛圧eserved锛� 
    0x2锛歀OW 
    0x3锛欻I 
    0x4锛欰UTO 1 
    0x5锛欰UTO 2 
    0x7锛欵rror
    Axera:
    "3: Continuous fast
    2: Continuous slow
    1: Error
    0: OFF*/
    switch (FrontWiperSt_temp)
    {
    case 0:
        VedCANInData.VehSigAdd.WiperStage = 0;
        break;
    case 2:
        VedCANInData.VehSigAdd.WiperStage = 2;
        break;
    case 3:
        VedCANInData.VehSigAdd.WiperStage = 3;
        break;
    default:
        VedCANInData.VehSigAdd.WiperStage = 7;
        break;
    }
    
    VedCANInData.VehSigAdd.WiperOutParkPos =
        0;  // WiperOutParkPos, Default
    Rte_Read_BCM_FrontWasherSt_BCM_FrontWasherSt(
        &(VedCANInData.VehSigAdd.WiperWasherFrontState));
    VedCANInData.VehSigAdd.RainSensor = 0;  // RainSensor, Default
    uint8 TurnSignal_temp;
    Rte_Read_BCM_TurnLightSwitchSt_BCM_TurnLightSwitchSt(
        &(TurnSignal_temp));
    /*
    Axera
    "3: Error
    2: Right turn active 
    1: Left turn active 
    0: Not active
    EP40:
    0x0: No request 
    0x1: Right lane change
    0x2: TurnRightStatus 
    0x3: Left lane change 
    0x4: TurnLeftStatus 
    0x7: Error			*/
    switch (TurnSignal_temp)
    {
    case 0:
        VedCANInData.VehSigAdd.TurnSignal = 0;
        break;
    case 1:
        VedCANInData.VehSigAdd.TurnSignal = 4;
        break;
    case 2:
        VedCANInData.VehSigAdd.TurnSignal = 2;
        break;
    default:
        VedCANInData.VehSigAdd.TurnSignal = 7;
        break;
    }
    
    Rte_Read_BCM_FrontFogLampSt_BCM_FrontFogLampSt(
        &(VedCANInData.VehSigAdd.FogLampFront));
    Rte_Read_BCM_RearFogLampSt_BCM_RearFogLampSt(
        &(VedCANInData.VehSigAdd.FogLampRear));
    VedCANInData.VehSigAdd.RoadWhlAngFr = 0;  // RoadWhlAngFr, Default
    VedCANInData.VehSigAdd.RoadWhlAngRe = 0;  // RoadWhlAngRe, Default
    Rte_Read_ICM_TotalOdometer_ICM_TotalOdometer(
        &(VedCANInData.VehSigAdd.Odometer));  // Odometer
    Rte_Read_VCU_EMS_AccPedalActPst_VCU_EMS_AccPedalActPst(
        &(VedCANInData.VehSigAdd.GasPedalPos));
    VedCANInData.VehSigAdd.KickDown = 0;  // KickDown, Default
    Rte_Read_VCU_EMS_BrkPedalSt_VCU_EMS_BrkPedalSt(
        &(VedCANInData.VehSigAdd.BrakePedalPressed));
    boolean DriverTired_temp;
    Rte_Read_DMS_FatigWarnSt_DMS_FatigWarnSt(
        &(DriverTired_temp));
    /*
    Axera
    7: Reserved
    6: Reserved
    5: Microsleep --Single Eye closure > 2 seconds
    4: Severe State--AVECLOS > 11% of frames with eye closures
    3: Cautionary State--AVECLOS 4 to 11% of frames with eye closures.
    2: Attentive--AVECLOS < 4% of frames with eye closures  
    1: Unknown--driver detected, but can't determine the fatigue level
    0: Unavailable--driver not detected
	EP40:
    0x0锛歂one 
    0x1锛欴river Fatigue 
    0x2锛欴river Distracted*/
    if (DriverTired_temp==2 || DriverTired_temp==3 ||
        DriverTired_temp==4|| DriverTired_temp==5){
            VedCANInData.VehSigAdd.DriverTired = 1;
        } else{
            VedCANInData.VehSigAdd.DriverTired = 0;
        }
    
    VedCANInData.VehSigAdd.SpeedUnit = 0;  // SpeedUnit, Default
    Rte_Read_ICM_VehInsSpd_ICM_VehInsSpd(
       &(VedCANInData.VehSigAdd.SpeedoSpeed));


    VedCANInData.VehSigAdd.TrailerConnection =
        0;  // TrailerConnection, Default
    VedCANInData.VehSigAdd.TrailerConnBeforeShutDown =
        0;  // TrailerConnBeforeShutDown, Default
    VedCANInData.VehSigAdd.TrailerLengthInput =
        0;  // TrailerLengthInput, Default
    VedCANInData.VehSigAdd.ParkAidDet_L = 0;  // ParkAidDet_L, Default
    VedCANInData.VehSigAdd.ParkAidDet_CL =
        0;  // ParkAidDet_CL, Default
    VedCANInData.VehSigAdd.ParkAidDet_CR =
        0;  // ParkAidDet_CR, Default
    VedCANInData.VehSigAdd.ParkAidDet_R = 0;  // ParkAidDet_R, Default
    // TODO(Zhanghanqi), there are two COM
    Rte_Read_BCM_KeySt_BCM_KeySt(
        &(VedCANInData.VehSigAdd.IgnitionSwitch));
    VedCANInData.VehSigAdd.eSuspensionSystem =
        0;                                              // eSuspensionSystem
    VedCANInData.VehSigAdd.eHeightLevel = 0;  // eHeightLevel
    // WheelHeightLevel
    VedCANInData.VehSigAdd.WheelHeightLevel.FrontLeft = 0;
    VedCANInData.VehSigAdd.WheelHeightLevel.FrontRight = 0;
    VedCANInData.VehSigAdd.WheelHeightLevel.RearLeft = 0;
    VedCANInData.VehSigAdd.WheelHeightLevel.RearRight = 0;
    uint8 DriverSeatBelt;
    Rte_Read_SRS_DriverSeatBeltSt_SRS_DriverSeatBeltSt(
        &(DriverSeatBelt));
    /*
    EP40:
    0x0: Buckled (fasten the seat belt)
    0x1: Unbuckled (the seat belt is not fastened)
    0x2: Fault (fasten seat belt)
    0x3: Not Avaliable (seat belt is not system)
    Axera:
    3: Invalid
    2: Not used
    1: Unfastened
    0: Fastened 
    */
   switch (DriverSeatBelt)
   {
   case 0:
        VedCANInData.VehSigAdd.bDriverSeatBelt_nu = 0;
        break;
   case 1:
        VedCANInData.VehSigAdd.bDriverSeatBelt_nu = 1;
        break;
    case 3:
        VedCANInData.VehSigAdd.bDriverSeatBelt_nu = 2;
        break;
   default:
        VedCANInData.VehSigAdd.bDriverSeatBelt_nu = 3;
        break;
   }
    VedCANInData.VehSigAdd.bDoorAllClosed_nu =
        0;  // bDoorAllClosed_nu
    Rte_Read_BCM_LowBeamSt_BCM_LowBeamSt(
        &(VedCANInData.VehSigAdd.bLowBeamActive_nu));
    Rte_Read_BCM_HighBeamSt_BCM_HighBeamSt(
        &(VedCANInData.VehSigAdd.bHighBeamActive_nu));
    Rte_Read_BCM_HazardLampSt_BCM_HazardLampSt(
        &(VedCANInData.VehSigAdd.bHazardLightActive_nu));
    VedCANInData.VehSigAdd.fBrakePedalPos_nu =
        0;  // fBrakePedalPos_nu
    // Rte_Read_BDCS1_FrontLampSt_ADCS_FD3_BDCS1_FrontLampSt_ADCS_FD3(
    //    &(VedCANInData.VehSigAdd.uFrontLampState_nu));
    VedCANInData.VehSigAdd.uFrontLampState_nu = 
        0; //set 0x0: off, Default
    // Rte_Read_CDCS11_VoiceMode_ADCS_FD3_CDCS11_VoiceMode_ADCS_FD3(
    //    &(VedCANInData.VehSigAdd.CDCS11_VoiceMode));
    VedCANInData.VehSigAdd.CDCS11_VoiceMode =
        0; // set 0x0: noaction, Default

    if (VedCANInData.VehSigAdd.CDCS11_VoiceMode == 2 &&
        uCDCS11_VoiceMode != 1) {
        uCDCS11_VoiceMode = 1;
    }
    if (VedCANInData.VehSigAdd.CDCS11_VoiceMode == 1 &&
        uCDCS11_VoiceMode != 0) {
        uCDCS11_VoiceMode = 0;
    }
    VedCANInData.VehSigAdd.CDCS11_VoiceMode = uCDCS11_VoiceMode;
    // Rte_Read_CDCS11_ADAS_SndCtrlOnOff_ADCS_FD3_CDCS11_ADAS_SndCtrlOnOff_ADCS_FD3(
    //    &(VedCANInData.VehSigAdd.CDCS11_ADAS_SndCtrlOnOff));
    VedCANInData.VehSigAdd.CDCS11_ADAS_SndCtrlOnOff =
        2; //set 0x2:OFF, Default

    Rte_Read_EPS_StrngWhlTorq_EPS_StrngWhlTorq(
        &(VedCANInData.VehSigAdd.EPS1_TorsionBarTorque));  // EPS1_TorsionBarTorque
    // Rte_Read_CS1_GearPositionReqSt_ADCS_FD3_CS1_GearPositionReqSt_ADCS_FD3(
    //     &(VedCANInData.VehSigAdd.CS1_GearPositionReqSt));
    VedCANInData.VehSigAdd.CS1_GearPositionReqSt = 0; //todo: for lateral
    //Rte_Read_EPS_SteeringModeSt_EPS_SteeringModeSt(
    //    &(VedCANInData.VehSigAdd.EPS2_ADAS_Available));
    //Rte_Read_EPS_AssistPraSwitchToLKA_EPS_AssistPraSwitchToLKA(
    //    &(VedCANInData.VehSigAdd.EPS2_ADAS_Active));
    Rte_Read_VCU_ActVehWheelTorq_VCU_ActVehWheelTorq(
        &(VedCANInData.VehSigAdd.EPS2_MotCntrl));  // EPS2_MotCntrl
    uint8 CtrlAbortFeedback;
    Rte_Read_EPS_LKACtrlAbortFeedback_EPS_LKACtrlAbortFeedback(
        &(VedCANInData.VehSigAdd.EPS2_ADAS_CtrlAbortFeedback));
    /*
    EP40:
    0x0锛歂o error 
    0x1锛欴river override 
    0x2锛歏ehicle Speed Invalid 
    0x3锛歄ver speed 
    0x4锛欵PS Permanently error 
    0x5锛欵PS Temporary error 
    0x6锛欰DAS transmission signal error 
    0x7锛歊equest Slope over range 
    0x8锛歊equest Value over range 
    0x9锛欰DAS activation request error 
    0xA: Parking interruption
    Axera:
    15: Reserved
    14: Reserved
    13: Reserved
    12: Reserved
    11: APA Interruption(P1);Reserved(P2)
    10: EPS Permanently error
    9: Failed Temp Time Over Limit
    8: Request Torque Value over range
    7: Request Torque Slope over range
    6: EPS Temporary error
    5: IFC_2 Signal error
    4: IFC Activation Request Error
    3: Vehicle Speed Invalid
    2: Driver override
    1: Driver hands off
    0: No interruption*/
    /*switch (CtrlAbortFeedback)
    {
    case 0:
        VedCANInData.VehSigAdd.EPS2_ADAS_CtrlAbortFeedback = 0;
        break;
    case 2:
        VedCANInData.VehSigAdd.EPS2_ADAS_CtrlAbortFeedback = 1;
        break;
    case 3:
        VedCANInData.VehSigAdd.EPS2_ADAS_CtrlAbortFeedback = 2;
        break;
    case 6:
        VedCANInData.VehSigAdd.EPS2_ADAS_CtrlAbortFeedback = 5;
        break;
    case 7:
        VedCANInData.VehSigAdd.EPS2_ADAS_CtrlAbortFeedback = 7;
        break;
    case 8:
        VedCANInData.VehSigAdd.EPS2_ADAS_CtrlAbortFeedback = 8;
        break;
    case 10:
        VedCANInData.VehSigAdd.EPS2_ADAS_CtrlAbortFeedback = 4;
        break;
    default:
        VedCANInData.VehSigAdd.EPS2_ADAS_CtrlAbortFeedback = 9;
        break;
    }*/
    uint8 FLDoorAjar;
    Rte_Read_BCM_DriverDoorAjarSt_BCM_DriverDoorAjarSt(
        &(FLDoorAjar));
    if (FLDoorAjar ==1){
        VedCANInData.VehSigAdd.DDCU1_FLDoorAjar = 2;
    } else{
        VedCANInData.VehSigAdd.DDCU1_FLDoorAjar = 0;
    }
    uint8 RLDoorAjar;
    Rte_Read_BCM_RLDoorAjarSt_BCM_RLDoorAjarSt(
        &(RLDoorAjar));
    if (RLDoorAjar ==1){
        VedCANInData.VehSigAdd.DDCU1_RLDoorAjar = 2;
    } else{
        VedCANInData.VehSigAdd.DDCU1_RLDoorAjar = 0;
    }
    uint8 FRDoorAjar;
    Rte_Read_BCM_PsngrDoorAjarSt_BCM_PsngrDoorAjarSt(
        &(FRDoorAjar));
    if (FRDoorAjar ==1){
        VedCANInData.VehSigAdd.PDCU1_FRDoorAjar = 2;
    } else{
        VedCANInData.VehSigAdd.PDCU1_FRDoorAjar = 0;
    }
    uint8 RRDoorAjar;
    Rte_Read_BCM_RRDoorAjarSt_BCM_RRDoorAjarSt(
        &(RRDoorAjar));
    if (RRDoorAjar ==1){
        VedCANInData.VehSigAdd.PDCU1_RRDoorAjar = 2;
    } else{
        VedCANInData.VehSigAdd.PDCU1_RRDoorAjar = 0;
    }
    // Rte_Read_BDCS1_TrunkLockSts_ADCS_FD3_BDCS1_TrunkLockSts_ADCS_FD3(
    //    &(VedCANInData.VehSigAdd.BDCS1_TrunkLockSts));
    VedCANInData.VehSigAdd.BDCS1_TrunkLockSts =
        1; //set as 0x1:locked, Default
    // Rte_Read_BDCS1_HoodAjarSts_ADCS_FD3_BDCS1_HoodAjarSts_ADCS_FD3(
    //    &(VedCANInData.VehSigAdd.BDCS1_HoodAjarSts));
    VedCANInData.VehSigAdd.BDCS1_HoodAjarSts = 
        0; //set as 0x0: closed, Default
    // Rte_Read_CDCS5_ResetAllSetup_ADCS_FD3_CDCS5_ResetAllSetup_ADCS_FD3(
    //    &(VedCANInData.VehSigAdd.CDCS5_ResetAllSetup));
    VedCANInData.VehSigAdd.CDCS5_ResetAllSetup =
        0; //set as 0x0: no action, Default
    // Rte_Read_CDCS5_FactoryReset_ADCS_FD3_CDCS5_FactoryReset_ADCS_FD3(
    //    &(VedCANInData.VehSigAdd.CDCS5_FactoryReset));
    VedCANInData.VehSigAdd.CDCS5_FactoryReset =
        0; // set as 0x0: no action, Default
    //  VEDPowerTrain_t
    VedCANInData.PowerTrain.ActualGear = 0;     // ActualGear
    VedCANInData.PowerTrain.TargetGear = 0;     // TargetGear
    VedCANInData.PowerTrain.EngineRunning = 0;  // EngineRunning
    VedCANInData.PowerTrain.FillByte = 0;       // FillByte
    Rte_Read_VCU_CrntGearLvlVD_VCU_CrntGearLvlVD(&status);
    VedCANInData.PowerTrain.state[0] = VED_CANIN_STATUS_MAP(status);

    // Rte_Read_CS1_GearPositionReqStValid_ADCS_FD3_CS1_GearPositionReqStValid_ADCS_FD3(
    //     &VedCANInData.PowerTrain.state[1]);
    VedCANInData.PowerTrain.state[1] = 0; //todo remove CS1_GearPositionReqStValid
    VedCANInData.PowerTrain.state[2] = 0;  // EngineRunning_Valid
    VedCANInData.PowerTrain.state[3] = 0;  // FillByte_Valid
    // VED_CANIn VEDBrake_t
    VedCANInData.Brake.State[0] = 0;   // ABSCtrl_Valid
    VedCANInData.Brake.State[1] = 0;   // TCSCtrl_Valid
    VedCANInData.Brake.State[2] = 0;   // bESCActive_nu_Valid
    VedCANInData.Brake.State[3] = 0;   // bESCDisable_nu_Valid
    VedCANInData.Brake.State[4] = 0;   // bTCSDisable_nu_Valid
    VedCANInData.Brake.State[5] = 0;   // IDB5_ABAavailable_Valid
    VedCANInData.Brake.State[6] = 0;   // IDB5_JerkActive_Valid
    VedCANInData.Brake.State[7] = 0;   // IDB5_Jerkfail_Valid
    VedCANInData.Brake.State[8] = 0;   // IDB5_AEB_Enable_Valid
    VedCANInData.Brake.State[9] = 0;   // IDB7_ARPACTIVE_Valid
    VedCANInData.Brake.State[10] = 0;  // IDB7_ARPFailure_Valid
    VedCANInData.Brake.State[11] = 0;  // IDB1_FailedState_Valid
    VedCANInData.Brake.State[12] = 0;  // bHDCEnable_nu_Valid

    Rte_Read_BCS_ABSActiveSt_BCS_ABSActiveSt(
        &(VedCANInData.Brake.ABSCtrl));
    Rte_Read_BCS_TCSActiveSt_BCS_TCSActiveSt(
        &(VedCANInData.Brake.TCSCtrl));
    //Rte_Read_IDB7_ESCActive_ADCS_FD3_IDB7_ESCActive_ADCS_FD3(
    //    &(VedCANInData.Brake.bESCActive_nu));
    VedCANInData.Brake.bESCActive_nu = 0; //set to not active, Default
    // Rte_Read_IDB7_ESCDisable_ADCS_FD3_IDB7_ESCDisable_ADCS_FD3(
    //    &(VedCANInData.Brake.bESCDisable_nu));
    VedCANInData.Brake.bESCDisable_nu =
        0; //Set to enable : 0x0, Default    
    Rte_Read_BCS_TCSOff_BCS_TCSOff(
        &(VedCANInData.Brake.bTCSDisable_nu));
    // TODO liujinjin check
    VedCANInData.Brake.IDB5_ABAavailable = 0;  // IDB5_ABAavailable
    Rte_Read_BCS_AWBActive_BCS_AWBActive(
        &(VedCANInData.Brake.IDB5_JerkActive));
    // Rte_Read_IDB5_Jerkfail_ADCS_FD3_IDB5_Jerkfail_ADCS_FD3(
    //    &(VedCANInData.Brake.IDB5_Jerkfail));
    VedCANInData.Brake.IDB5_Jerkfail =
        0; //set as no fail: 0x0, Default   
    uint8 AEB_Enable;
    Rte_Read_BCS_AEBAvailable_BCS_AEBAvailable(
        &(VedCANInData.Brake.IDB5_AEB_Enable));
    /*
    EP40:
    0x0锛欰vailable 
    0x1锛歍emporarily not Available 
    0x2锛歅ermanently not Available 
    0x3锛欰EB Communication Error
    Axera: 
    1: Available
    0: Not available
    */
    if (AEB_Enable ==1){
        VedCANInData.Brake.IDB5_AEB_Enable =0;
    } else{
        VedCANInData.Brake.IDB5_AEB_Enable =2;
    }
    // Rte_Read_IDB7_ARPACTIVE_ADCS_FD3_IDB7_ARPACTIVE_ADCS_FD3(
    //     &(VedCANInData.Brake.IDB7_ARPACTIVE));
    VedCANInData.Brake.IDB7_ARPACTIVE = 0u;
    // Rte_Read_IDB7_ARPFailure_ADCS_FD3_IDB7_ARPFailure_ADCS_FD3(
    //     &(VedCANInData.Brake.IDB7_ARPFailure));
    VedCANInData.Brake.IDB7_ARPFailure = 0u;
    // Rte_Read_IDB1_FailedState_ADCS_FD3_IDB1_FailedState_ADCS_FD3(
    //    &(VedCANInData.Brake.IDB1_FailedState));
    VedCANInData.Brake.IDB1_FailedState =
        0; //Set to not-failed =0, Default
    boolean HDCEnable;
    Rte_Read_BCS_HDCCtrlSt_BCS_HDCCtrlSt(
        &(HDCEnable));
    if (HDCEnable ==1 || HDCEnable==2){
        VedCANInData.Brake.bHDCEnable_nu = 1;
    } else {
        VedCANInData.Brake.bHDCEnable_nu = 0;
    }
}

static void VED_Read_CANIn(reqVEDPrtList_t* pRequirePorts) {
    // CAN Bus time stamp
    uint32 u32vedtimestamp_us;
    uint64 u64vedtimestamp_us;
    // R_IoHwAbs_System_Timer_Get_32bit_1usec_Current_Value(&u32vedtimestamp_us);
    R_IoHwAbs_System_Timer_Get_64bit_1usec_Current_Value(&u64vedtimestamp_us);
    u32vedtimestamp_us = (uint32)u64vedtimestamp_us;
    pRequirePorts->pVehicleInputSignals->sSigHeader.uiTimeStamp = u32vedtimestamp_us;
    CanMsgInTimeStamp.is_valid = TRUE;
    CanMsgInTimeStamp.secs = (uint32)(u32vedtimestamp_us / 1000000u);
    CanMsgInTimeStamp.nsecs = 0u;
    // system time stamp
    pRequirePorts->pCtrl->uiSystemTimeStamp_us = u32vedtimestamp_us;

    if (pRequirePorts->pVehicleInputSignals->sSigHeader.uiMeasurementCounter >=
            0u &&
        pRequirePorts->pVehicleInputSignals->sSigHeader.uiMeasurementCounter <
            65535u) {
        pRequirePorts->pVehicleInputSignals->sSigHeader.uiMeasurementCounter +=
            1u;
    } else if (pRequirePorts->pVehicleInputSignals->sSigHeader
                   .uiMeasurementCounter >= 65535u) {
        pRequirePorts->pVehicleInputSignals->sSigHeader.uiMeasurementCounter =
            65535u;
    } else {
        pRequirePorts->pVehicleInputSignals->sSigHeader.uiMeasurementCounter =
            0u;
    }
    if (pRequirePorts->pVehicleInputSignals->sSigHeader.uiCycleCounter >= 0u &&
        pRequirePorts->pVehicleInputSignals->sSigHeader.uiCycleCounter <
            65535u) {
        pRequirePorts->pVehicleInputSignals->sSigHeader.uiCycleCounter += 1u;
    } else if (pRequirePorts->pVehicleInputSignals->sSigHeader.uiCycleCounter >=
               65535u) {
        pRequirePorts->pVehicleInputSignals->sSigHeader.uiCycleCounter = 65535u;
    } else {
        pRequirePorts->pVehicleInputSignals->sSigHeader.uiCycleCounter = 0u;
    }
    pRequirePorts->pVehicleInputSignals->sSigHeader.eSigStatus = 1u;

    // signal valid state
    for (uint8 i = 0; i < 32u; i++) {
        pRequirePorts->pVehicleInputSignals->VehSigMain.State[i] = 1u;
    }

    // YawRate
    // pRequirePorts->pVehicleInputSignals->VehSigMain.YawRate =
    //    VedCANInData.VehSigMain.YawRate / 57.3f; 
    pRequirePorts->pVehicleInputSignals->VehSigMain.YawRate =
        VedCANInData.VehSigMain.YawRate;   // in Axera the VedCANInData.VehSigMain.YawRate is in Rad/s
    pRequirePorts->pVehicleInputSignals->VehSigMain.State[0] =
        VedCANInData.VehSigMain.state[0];
    // StWheelAngle
    pRequirePorts->pVehicleInputSignals->VehSigMain.StWheelAngle =
        VedCANInData.VehSigMain.StWheelAngle / 57.3f;     
    pRequirePorts->pVehicleInputSignals->VehSigMain.State[2] =
        VedCANInData.VehSigMain.state[2];
    // LatAccel
    pRequirePorts->pVehicleInputSignals->VehSigMain.LatAccel =
        0.0 - VedCANInData.VehSigMain.LatAccel;
    if (!VedCANInData.VehSigMain.state[3]) {
        pRequirePorts->pVehicleInputSignals->VehSigMain.State[3] = 0u;
        g_ACU2_LatAccSensorValue = 0.0 - VedCANInData.VehSigMain.LatAccel;
    } else {
        pRequirePorts->pVehicleInputSignals->VehSigMain.State[3] = 1u;
        g_ACU2_LatAccSensorValue = 0.0f;
    }
    // WhlVelFrLeft
    pRequirePorts->pVehicleInputSignals->VehSigMain.WhlVelFrLeft =
        VedCANInData.VehSigMain.WhlVelFrLeft / 3.6;
    pRequirePorts->pVehicleInputSignals->VehSigMain.State[4] =
        VedCANInData.VehSigMain.state[4];
    // WhlVelFrRight
    pRequirePorts->pVehicleInputSignals->VehSigMain.WhlVelFrRight =
        VedCANInData.VehSigMain.WhlVelFrRight / 3.6;
    pRequirePorts->pVehicleInputSignals->VehSigMain.State[5] =
        VedCANInData.VehSigMain.state[5];
    // WhlVelReLeft
    pRequirePorts->pVehicleInputSignals->VehSigMain.WhlVelReLeft =
        VedCANInData.VehSigMain.WhlVelReLeft / 3.6;
    pRequirePorts->pVehicleInputSignals->VehSigMain.State[6] =
        VedCANInData.VehSigMain.state[6];
    // WhlVelReRight
    pRequirePorts->pVehicleInputSignals->VehSigMain.WhlVelReRight =
        VedCANInData.VehSigMain.WhlVelReRight / 3.6;
    pRequirePorts->pVehicleInputSignals->VehSigMain.State[7] =
        VedCANInData.VehSigMain.state[7];
    // VehVelocityExt
    pRequirePorts->pVehicleInputSignals->VehSigMain.VehVelocityExt =
        VedCANInData.VehSigMain.VehVelocityExt / 3.6;
    pRequirePorts->pVehicleInputSignals->VehSigMain.State[12] =
        VedCANInData.VehSigMain.state[12];
    // VehLongAccelExt
    pRequirePorts->pVehicleInputSignals->VehSigMain.VehLongAccelExt =
        VedCANInData.VehSigMain.VehLongAccelExt;
    pRequirePorts->pVehicleInputSignals->VehSigMain.State[13] =
        VedCANInData.VehSigMain.state[13];

    // wheel direction in Axera: 0 forward, 1 backward but in EP40: 1 forward, 2 backward (0 standstill,  3 not identified)
    if (VedCANInData.VehSigMain.WhlDirFrLeft == 1)
    {
        pRequirePorts->pVehicleInputSignals->VehSigMain.WhlDirFrLeft = 2u;
    } else {
        pRequirePorts->pVehicleInputSignals->VehSigMain.WhlDirFrLeft = 1u;
    }

    if (VedCANInData.VehSigMain.WhlDirFrRight == 1)
    {
        pRequirePorts->pVehicleInputSignals->VehSigMain.WhlDirFrRight = 2u;
    } else {
        pRequirePorts->pVehicleInputSignals->VehSigMain.WhlDirFrRight = 1u;
    }

    if (VedCANInData.VehSigMain.WhlDirReLeft == 1)
    {
        pRequirePorts->pVehicleInputSignals->VehSigMain.WhlDirReLeft =2u;
    } else {
        pRequirePorts->pVehicleInputSignals->VehSigMain.WhlDirReLeft =1u;
    }

    if (VedCANInData.VehSigMain.WhlDirReRight ==1)
    {
        pRequirePorts->pVehicleInputSignals->VehSigMain.WhlDirReRight =2u;
    } else{
        pRequirePorts->pVehicleInputSignals->VehSigMain.WhlDirReRight =1u;
    }
    // pRequirePorts->pVehicleInputSignals->VehSigMain.WhlDirFrLeft =
    //    VedCANInData.VehSigMain.WhlDirFrLeft;
    pRequirePorts->pVehicleInputSignals->VehSigMain.State[14] =
        VedCANInData.VehSigMain.state[14];
    // pRequirePorts->pVehicleInputSignals->VehSigMain.WhlDirFrRight =
    //    VedCANInData.VehSigMain.WhlDirFrRight;
    pRequirePorts->pVehicleInputSignals->VehSigMain.State[15] =
        VedCANInData.VehSigMain.state[15];
    // pRequirePorts->pVehicleInputSignals->VehSigMain.WhlDirReLeft =
    //    VedCANInData.VehSigMain.WhlDirReLeft;
    pRequirePorts->pVehicleInputSignals->VehSigMain.State[16] =
        VedCANInData.VehSigMain.state[16];
    // pRequirePorts->pVehicleInputSignals->VehSigMain.WhlDirReRight =
    //    VedCANInData.VehSigMain.WhlDirReRight;
    pRequirePorts->pVehicleInputSignals->VehSigMain.State[17] =
        VedCANInData.VehSigMain.state[17];
    pRequirePorts->pVehicleInputSignals->VehSigMain.State[18] = 1u;
    pRequirePorts->pVehicleInputSignals->VehSigMain.State[19] = 1u;
    pRequirePorts->pVehicleInputSignals->VehSigMain.State[20] = 1u;
    pRequirePorts->pVehicleInputSignals->VehSigMain.State[21] = 1u;

    // ActGearPos
    // VED:0_N/1_P/2_D/3_R/10_invalid 
    // in Axera:   0_Invalid/1_D/2_N/3_R/4_P/5,6,7_not used
    // EP40:0_default/1_P/2_R/3_N/4_D/5_S/7_Invalid
    switch (VedCANInData.VehSigMain.ActGearPos) {
        case 1:
            pRequirePorts->pVehicleInputSignals->VehSigMain.ActGearPos = 2u;
            break;
        case 2:
            pRequirePorts->pVehicleInputSignals->VehSigMain.ActGearPos = 0u;
            break;
        case 3:
            pRequirePorts->pVehicleInputSignals->VehSigMain.ActGearPos = 3u;
            break;
        case 4:
            pRequirePorts->pVehicleInputSignals->VehSigMain.ActGearPos = 1u;
            break;
 //       case 5:
 //           pRequirePorts->pVehicleInputSignals->VehSigMain.ActGearPos = 2u;
 //           break;
        default:
            pRequirePorts->pVehicleInputSignals->VehSigMain.ActGearPos = 10u;
            break;
    }
    pRequirePorts->pVehicleInputSignals->VehSigMain.State[22] =
        VedCANInData.VehSigMain.state[22];
    // ParkBrakeState
    /*
    EPB_SysSt : 
    EP40:
    0x0锛歎nknown unknown 
    0x1锛歊eleased clamp 
    0x2锛欳lamped clamp 
    0x3锛欳lamping in progress 
    0x4锛歊eleasing in progress 
    0x5锛欴ynamic braking via EPB dynamic braking 
    0x6锛欶ull Released 
    0x7锛歂ot Initialized (NEW)
    Axera:
    7: Fault(not sure position)
    6: Not used
    5: Not used
    4: Disengaged
    3: Applying
    2: Releasing
    1: Apply (fully applied)
    0: Release (fully released)*/
    // VED: 0,brake is off; 1,brake is on;
    if (VedCANInData.VehSigMain.ParkBrakeState == 0u) {
        pRequirePorts->pVehicleInputSignals->VehSigMain.ParkBrakeState = 0u;
    } else {
        pRequirePorts->pVehicleInputSignals->VehSigMain.ParkBrakeState = 1u;
    }


    
    pRequirePorts->pVehicleInputSignals->VehSigMain.State[24] =
        VedCANInData.VehSigMain.state[24];
    
    pRequirePorts->pVehicleInputSignals->VehSigMain.fStWheelAngleGradient_nu =
        VedCANInData.VehSigMain.fStWheelAngleGradient_nu / 57.3f;
    pRequirePorts->pVehicleInputSignals->VehSigMain.State[30] =
        VedCANInData.VehSigMain.state[30];

    // pRequirePorts->pVehicleInputSignals->VehSigAdd.EPS2_ADAS_Available =
    //     VedCANInData.VehSigAdd.EPS2_ADAS_Available;
    memcpy(&pRequirePorts->pVehicleInputSignals->VehSigAdd,
           &VedCANInData.VehSigAdd, sizeof(VEDVehSigAdd_t));
    memcpy(&pRequirePorts->pVehicleInputSignals->PowerTrain,
           &VedCANInData.PowerTrain, sizeof(VEDPowerTrain_t));
    memcpy(&pRequirePorts->pVehicleInputSignals->Brake, &VedCANInData.Brake,
           sizeof(VEDBrake_t));
}

static void VED_Write_VEDVehDyn(proVEDPrtList_t* pProvidePorts) {
    ST_VEDVehDyn_t* pVEDVehDynData;
    pVEDVehDynData = (ST_VEDVehDyn_t*)pProvidePorts->pVehicleDynamicSignals;
    Rte_Write_ST_VEDVehDyn_t_ST_VEDVehDyn_t(pVEDVehDynData);
    Rte_Write_pVED_ST_VEDVehDyn_t_ST_VEDVehDyn_t(pVEDVehDynData);
}

static void VED_Write_VEDVehSig(proVEDPrtList_t* pProvidePorts) {
    ST_VEDVehSig_t* pVEDVehSigData;
    // 闇�瑕佹坊鍔犻�忎紶淇″彿
    pVEDVehSigData = (ST_VEDVehSig_t*)pProvidePorts->pOriginVehicleSignals;
    Rte_Write_ST_VEDVehSig_t_ST_VEDVehSig_t(pVEDVehSigData);
}

static void VED_Write_VEDNvIoDatas(proVEDPrtList_t* pProvidePorts) {}

static void VED_Write_EMVEDVehPar(proVEDPrtList_t* pProvidePorts) {
    ST_EMVEDVehPar_t EMVEDVehParData;

    // UNIF_InitVehicleParameter1(&EMVEDVehParData);
    Rte_Write_ST_EMVEDVehPar_t_ST_EMVEDVehPar_t(&EMVEDVehParData);
}

static void VED_Write_VehicleDynamicSignals(proVEDPrtList_t* pProvidePorts) {
    static ST_VehicleDynamicSignals_t VehicleDynamicSignalsData;
    // system time stamp
    uint32 u32vedtimestamp_us;
    uint64 u64vedtimestamp_us;
    // R_IoHwAbs_System_Timer_Get_32bit_1usec_Current_Value(&u32vedtimestamp_us);
    R_IoHwAbs_System_Timer_Get_64bit_1usec_Current_Value(&u64vedtimestamp_us);
    u32vedtimestamp_us = (uint32)u64vedtimestamp_us;
    VehicleDynamicSignalsData.timestamp_t.is_valid = TRUE;
    VehicleDynamicSignalsData.timestamp_t.secs = (uint32)(u32vedtimestamp_us / 1000000u);
    VehicleDynamicSignalsData.timestamp_t.nsecs = 0u;
    // can time
    VehicleDynamicSignalsData.measurement_time.is_valid =
        CanMsgInTimeStamp.is_valid;
    VehicleDynamicSignalsData.measurement_time.secs = CanMsgInTimeStamp.secs;
    VehicleDynamicSignalsData.measurement_time.nsecs = CanMsgInTimeStamp.nsecs;

    VehicleDynamicSignalsData.angular_velocity.x = 0.f;
    VehicleDynamicSignalsData.angular_velocity.y = 0.f;
    VehicleDynamicSignalsData.angular_velocity.z =
        pProvidePorts->pVehicleDynamicSignals->Lateral.YawRate.YawRate;

    VehicleDynamicSignalsData.linear_acceleration.x =
        pProvidePorts->pVehicleDynamicSignals->Longitudinal.MotVar.Accel;
    VehicleDynamicSignalsData.linear_acceleration.y = g_ACU2_LatAccSensorValue;
    VehicleDynamicSignalsData.linear_acceleration.z = 0.f;

    VehicleDynamicSignalsData.linear_velocity.x =
        pProvidePorts->pVehicleDynamicSignals->Longitudinal.MotVar.Velocity;
    VehicleDynamicSignalsData.linear_velocity.y = 0.f;
    VehicleDynamicSignalsData.linear_velocity.z = 0.f;

    VehicleDynamicSignalsData.status_info = 1u;

    VehicleDynamicSignalsData.curve.c1 =
        pProvidePorts->pVehicleDynamicSignals->Lateral.Curve.C1;
    VehicleDynamicSignalsData.curve.crv_conf =
        pProvidePorts->pVehicleDynamicSignals->Lateral.Curve.CrvConf;
    VehicleDynamicSignalsData.curve.crv_error =
        pProvidePorts->pVehicleDynamicSignals->Lateral.Curve.CrvError;
    VehicleDynamicSignalsData.curve.curve =
        pProvidePorts->pVehicleDynamicSignals->Lateral.Curve.Curve;
    VehicleDynamicSignalsData.curve.gradient =
        pProvidePorts->pVehicleDynamicSignals->Lateral.Curve.Gradient;
    VehicleDynamicSignalsData.curve.quality =
        pProvidePorts->pVehicleDynamicSignals->Lateral.Curve.Quality;
    VehicleDynamicSignalsData.curve.var_c0 =
        pProvidePorts->pVehicleDynamicSignals->Lateral.Curve.varC0;
    VehicleDynamicSignalsData.curve.var_c1 =
        pProvidePorts->pVehicleDynamicSignals->Lateral.Curve.varC1;

#if ENABLE_MCU2SOC_TEST == 1
    init_Debug_VehicleDynamicSignals(&VehicleDynamicSignalsData);
#endif
    // Rte_Write_ST_VehicleDynamicSignals_t_ST_VehicleDynamicSignals_t(
    //     &VehicleDynamicSignalsData);
}

static void VED_Write_NVRAM_Data(proVEDPrtList_t* pProvidePorts) {
    g_VEDNVRAM_Data.checkSum = pProvidePorts->pNVMWrite->checkSum;
    g_VEDNVRAM_Data.State = pProvidePorts->pNVMWrite->State;
    g_VEDNVRAM_Data.uiVersionNumber = pProvidePorts->pNVMWrite->uiVersionNumber;
    memcpy(&g_VEDNVRAM_Data.LatAcc, &pProvidePorts->pNVMWrite->LatAcc,
           sizeof(VEDLatAcc_t));
    memcpy(&g_VEDNVRAM_Data.SlfstGrad, &pProvidePorts->pNVMWrite->SlfstGrad,
           sizeof(VEDNvSlfStGradCalc_t));
    memcpy(&g_VEDNVRAM_Data.sSigHeader, &pProvidePorts->pNVMWrite->sSigHeader,
           sizeof(VEDSignalHeader_t));
    memcpy(&g_VEDNVRAM_Data.StWhlAng, &pProvidePorts->pNVMWrite->StWhlAng,
           sizeof(VEDNvStWhlAngCalc_t));
    memcpy(&g_VEDNVRAM_Data.VelCorr, &pProvidePorts->pNVMWrite->VelCorr,
           sizeof(VelCorr_array_t));
    memcpy(&g_VEDNVRAM_Data.Wld, &pProvidePorts->pNVMWrite->Wld,
           sizeof(VEDNvWldCalc_t));
    memcpy(&g_VEDNVRAM_Data.YwRate, &pProvidePorts->pNVMWrite->YwRate,
           sizeof(VEDYwRate_t));

    // Rte_Write_ST_VEDNvIoDatas_Write_t_ST_VEDNvIoDatas_Write_t(&g_VEDNVRAM_Data);
}

static void VED_Write_FaultDiagnosisData(proVEDPrtList_t* pProvidePorts) {
    // const VED_SwaOffsData_t* vel;
    // vel = VED_SwaGetOffsData();

    static ST_adcu_ved_dtc VED_adcu_ved_dtc;

    if (pProvidePorts->pVED_Offsets->Swa.State >= STEERING_OFFSET_STATE) {
        if (pProvidePorts->pVED_Offsets->Swa.Offset >=
            STEERING_ANGLE_THRESHOLD) {
            VED_adcu_ved_dtc.adcu_ved_dtc[1].dtc = 0xA537;
            VED_adcu_ved_dtc.adcu_ved_dtc[1].event_id = 0x4;
            VED_adcu_ved_dtc.adcu_ved_dtc[1].status = 0x1;
            // steering angle failure
        } else {
            // steering angle passing
            VED_adcu_ved_dtc.adcu_ved_dtc[1].dtc = 0x0;
            VED_adcu_ved_dtc.adcu_ved_dtc[1].event_id = 0x0;
            VED_adcu_ved_dtc.adcu_ved_dtc[1].status = 0x0;
        }
    } else {
        // nothing
        VED_adcu_ved_dtc.adcu_ved_dtc[1].dtc = 0x0;
        VED_adcu_ved_dtc.adcu_ved_dtc[1].event_id = 0x0;
        VED_adcu_ved_dtc.adcu_ved_dtc[1].status = 0x0;
    }

    static uint64 ui32_CountRunning = COUNT_RUNNING_MAX;
    static uint16 ui16_CountStandstill = COUNT_STANDSTILL_MAX;
    if (pProvidePorts->pVehicleDynamicSignals->MotionState.MotState == 3u) {
        ui32_CountRunning = COUNT_RUNNING_MAX;
        if ((pProvidePorts->pVED_Offsets->Ywr.StandStillOffset >
             STANDSTILL_OFFSET_THRESOLD) ||
            (pProvidePorts->pVED_Offsets->Ywr.StandStillOffset <
             ((-1) * STANDSTILL_OFFSET_THRESOLD))) {
            if (ui16_CountStandstill > 0) {
                ui16_CountStandstill--;
            } else {
                ui16_CountStandstill = 0;
            }
            if (ui16_CountStandstill == 0) {
                // Yawrate failure
                VED_adcu_ved_dtc.adcu_ved_dtc[0].dtc = 0xA536;
                VED_adcu_ved_dtc.adcu_ved_dtc[0].event_id = 0x2;
                VED_adcu_ved_dtc.adcu_ved_dtc[0].status = 0x1;
            } else {
                /*do nothing*/
                VED_adcu_ved_dtc.adcu_ved_dtc[0].dtc = 0x0;
                VED_adcu_ved_dtc.adcu_ved_dtc[0].event_id = 0x0;
                VED_adcu_ved_dtc.adcu_ved_dtc[0].status = 0x0;
            }
        } else {
            ui16_CountStandstill = COUNT_STANDSTILL_MAX;
            // Yawrate passing
            VED_adcu_ved_dtc.adcu_ved_dtc[0].dtc = 0x0;
            VED_adcu_ved_dtc.adcu_ved_dtc[0].event_id = 0x0;
            VED_adcu_ved_dtc.adcu_ved_dtc[0].status = 0x0;
        }
    } else if (pProvidePorts->pVehicleDynamicSignals->MotionState.MotState ==
                   1u ||
               pProvidePorts->pVehicleDynamicSignals->MotionState.MotState ==
                   2u) {
        ui16_CountStandstill = COUNT_STANDSTILL_MAX;
        if ((pProvidePorts->pVED_Offsets->Ywr.DynOffset >
             STANDSTILL_OFFSET_THRESOLD) ||
            (pProvidePorts->pVED_Offsets->Ywr.DynOffset <
             ((-1) * STANDSTILL_OFFSET_THRESOLD))) {
            if (ui32_CountRunning > 0) {
                ui32_CountRunning--;
            } else {
                ui32_CountRunning = 0;
            }

            if (ui32_CountRunning == 0) {
                // yawrate Dyn failure
                VED_adcu_ved_dtc.adcu_ved_dtc[0].dtc = 0xA536;
                VED_adcu_ved_dtc.adcu_ved_dtc[0].event_id = 0x2;
                VED_adcu_ved_dtc.adcu_ved_dtc[0].status = 0x1;
            } else {
                /* Do Nothing */
                VED_adcu_ved_dtc.adcu_ved_dtc[0].dtc = 0x0;
                VED_adcu_ved_dtc.adcu_ved_dtc[0].event_id = 0x0;
                VED_adcu_ved_dtc.adcu_ved_dtc[0].status = 0x0;
            }
        } else {
            ui32_CountRunning = COUNT_RUNNING_MAX;
            // yawrate Dyn passing
            VED_adcu_ved_dtc.adcu_ved_dtc[0].dtc = 0x0;
            VED_adcu_ved_dtc.adcu_ved_dtc[0].event_id = 0x0;
            VED_adcu_ved_dtc.adcu_ved_dtc[0].status = 0x0;
        }

    } else {
        // nothing
        VED_adcu_ved_dtc.adcu_ved_dtc[0].dtc = 0x0;
        VED_adcu_ved_dtc.adcu_ved_dtc[0].event_id = 0x0;
        VED_adcu_ved_dtc.adcu_ved_dtc[0].status = 0x0;
    }
    Rte_Write_ST_adcu_ved_dtc_ST_adcu_ved_dtc(&VED_adcu_ved_dtc);
}

static void VED_RTE_InputWrapper() {
    ST_CANMsg_Read_VED_CANIn();
    VED_Read_CANIn(&g_VED_reqPorts); 
}

static void VED_RTE_OutputWrapper() {
    VED_Write_VEDVehDyn(&g_VED_proPorts);
    VED_Write_VEDVehSig(&g_VED_proPorts);
    VED_Write_VEDNvIoDatas(&g_VED_proPorts);
    VED_Write_EMVEDVehPar(&g_VED_proPorts);
    // VED_Write_VehicleDynamicSignals(&g_VED_proPorts);
    VED_Write_NVRAM_Data(&g_VED_proPorts);
    VED_Write_FaultDiagnosisData(&g_VED_proPorts);
}

void VED_Initialize(void) {
    ST_CarConfigParamOut CarConfigParamIn;
    Rte_Read_ST_CarConfigParamOut_ST_CarConfigParamOut(&CarConfigParamIn);
    // input
    memset(&g_pCtrl, 0, sizeof(BSW_s_VEDCtrlData_t));
    memset(&g_pVehicleInputSignals, 0, sizeof(VEDVehSig_t));
    memset(&g_pNVMRead, 0, sizeof(VEDNvIoDatas_t));
    memset(&g_pAln_Monitoring, 0, sizeof(VEDALN_Monitoring_t));
    g_VED_reqPorts.pCtrl = &g_pCtrl;
    g_VED_reqPorts.pVehicleInputSignals = &g_pVehicleInputSignals;
    g_VED_reqPorts.pNVMRead = &g_pNVMRead;
    g_VED_reqPorts.pAln_Monitoring = &g_pAln_Monitoring;

    // output
    memset(&g_pVehicleDynamicSignals, 0, sizeof(VEDVehDyn_t));
    memset(&g_pNVMWrite, 0, sizeof(VEDNvIoDatas_t));
    memset(&g_pVED_Errors, 0, sizeof(VED_Errors_t));
    memset(&g_pVED_Offsets, 0, sizeof(VED_VEDOffsets_t));
    memset(&g_pVED_EstCurves, 0, sizeof(VED_EstCurves_t));
    memset(&g_pOriginVehicleSignals, 0, sizeof(VEDVehSig_t));
    g_VED_proPorts.pVehicleDynamicSignals = &g_pVehicleDynamicSignals;
    g_VED_proPorts.pNVMWrite = &g_pNVMWrite;
    g_VED_proPorts.pVED_Errors = &g_pVED_Errors;
    g_VED_proPorts.pVED_Offsets = &g_pVED_Offsets;
    g_VED_proPorts.pVED_EstCurves = &g_pVED_EstCurves;
    g_VED_proPorts.pOriginVehicleSignals = &g_pOriginVehicleSignals;

    // EP40 parameter
    memset(&g_VED_reqParams, 0, sizeof(reqVEDParams_t));
    g_VED_reqParams.VED_Kf_WheelBase_met = 2.96f;          // 2960mm
    g_VED_reqParams.VED_Kf_TrackWidthFront_met = 1.7f;     // 1700mm
    g_VED_reqParams.VED_Kf_TrackWidthRear_met = 1.707f;    // 1707mm
    g_VED_reqParams.VED_Kf_AxisLoadDistr_per = 0.48;       // 911.f / 1895.f;
    g_VED_reqParams.VED_Kf_WhlCircumference_met = 0.341f;  // 341mm

    switch (CarConfigParamIn.uCarParameter) {
        case 0:
            g_VED_reqParams.VED_Kf_VehWeight_kg = 2.055f;
            break;
        case 1:
            g_VED_reqParams.VED_Kf_VehWeight_kg = 1.87;
            break;
        case 2:
        default:
            g_VED_reqParams.VED_Kf_VehWeight_kg = 1.895;
            break;
    }

    // default parameter
    g_VED_reqParams.VED_Kf_SelfSteerGrad_nu = 0.003734f;
    g_VED_reqParams.SteeringRatio.swa.ang[0] = 0.0f;
    g_VED_reqParams.SteeringRatio.swa.ang[1] = 1000.0f;
    g_VED_reqParams.SteeringRatio.swa.rat[0] = 14.52000046f;
    g_VED_reqParams.SteeringRatio.swa.rat[1] = 17.0f;
    g_VED_reqParams.SteeringRatio.vel.vel[0] = 0.0f;
    g_VED_reqParams.SteeringRatio.vel.vel[1] = 0.0f;
    g_VED_reqParams.SteeringRatio.vel.rat[0] = 14.52000046f;
    g_VED_reqParams.SteeringRatio.vel.rat[1] = 14.52000046f;
    g_VED_reqParams.VED_Kf_CntrOfGravHeight_met = 0.63422f;
    g_VED_reqParams.VED_Kf_WhlLoadDepFrontAxle_nu = 3.6329999f;
    g_VED_reqParams.VED_Kf_WhlLoadDepRearAxle_nu = 2.92000008f;
    g_VED_reqParams.VED_Ku_WhlTcksPerRev_nu = 96.0f;
}

static boolean VED_Read_NVRAM_Data(reqVEDPrtList_t* pRequirePorts) {
    static boolean VED_NvramFlag = FALSE;
    if (VED_NvramFlag == FALSE) {
        // Rte_Read_ST_VED_NVRAMData_ReceiveFlag_ST_VED_NVRAMData_ReceiveFlag(
        //     &VED_NvramFlag);
        if (VED_NvramFlag == TRUE) {
            // Rte_Read_ST_VEDNvIoDatas_Read_t_ST_VEDNvIoDatas_Read_t(
            //     &g_VEDNVRAM_Data);
            VEDNvIoDatas_t* pNVMRead;
            pNVMRead = pRequirePorts->pNVMRead;
            pNVMRead->checkSum = g_VEDNVRAM_Data.checkSum;
            pNVMRead->State = g_VEDNVRAM_Data.State;
            pNVMRead->uiVersionNumber = g_VEDNVRAM_Data.uiVersionNumber;
            memcpy(&pNVMRead->LatAcc, &g_VEDNVRAM_Data.LatAcc,
                   sizeof(VEDLatAcc_t));
            memcpy(&pNVMRead->SlfstGrad, &g_VEDNVRAM_Data.SlfstGrad,
                   sizeof(VEDNvSlfStGradCalc_t));
            memcpy(&pNVMRead->sSigHeader, &g_VEDNVRAM_Data.sSigHeader,
                   sizeof(VEDSignalHeader_t));
            memcpy(&pNVMRead->StWhlAng, &g_VEDNVRAM_Data.StWhlAng,
                   sizeof(VEDNvStWhlAngCalc_t));
            memcpy(&pNVMRead->VelCorr, &g_VEDNVRAM_Data.VelCorr,
                   sizeof(VelCorr_array_t));
            memcpy(&pNVMRead->Wld, &g_VEDNVRAM_Data.Wld,
                   sizeof(VEDNvWldCalc_t));
            memcpy(&pNVMRead->YwRate, &g_VEDNVRAM_Data.YwRate,
                   sizeof(VEDYwRate_t));
        }
    }
    return VED_NvramFlag;
}

uint32 VEDProcess = 0;
void VED_StepExec(void) {
    // if (VED_Read_NVRAM_Data(&g_VED_reqPorts) == TRUE) {
        VED_operation_status_check = !VED_operation_status_check;
        VEDExec(&g_VED_reqPorts, &g_VED_reqParams, &g_VED_proPorts);
        VED_RTE_OutputWrapper();
        VEDProcess++;
    // }
}

// #define CORE5_MODULE_STOP_CODE
// #include "Mem_Map.h" /* PRQA S 5087 */ /* MD_MSR_MemMap */

// Input data pointer returner
reqVEDPrtList_t *p_VED_in() {
    return &g_VED_reqPorts;
}

proVEDPrtList_t *p_VED_out() {
    return &g_VED_proPorts;
}


reqVEDParams_t *p_VED_params() {
    return &g_VED_reqParams;
}
